/**
 * 
 */
package com.vdoc.selectors.view.providers;

import java.util.ArrayList;
import java.util.Collection;

import com.axemble.vdoc.sdk.Modules;
import com.axemble.vdoc.sdk.interfaces.IUser;
import com.axemble.vdoc.sdk.interfaces.runtime.INavigateContext;
import com.axemble.vdoc.sdk.modules.IDirectoryModule;
import com.axemble.vdoc.sdk.providers.BaseViewProvider;
import com.axemble.vdp.ui.core.providers.ICollectionViewProvider;
import com.axemble.vdp.ui.core.providers.ISelectorViewProvider;
import com.axemble.vdp.ui.framework.composites.base.CtlAbstractExplorer.CtlTabsGroup.CtlLauncher.CtlExplorerLink;
import com.axemble.vdp.ui.framework.composites.base.CtlAbstractView;
import com.axemble.vdp.ui.framework.composites.base.models.views.ViewModelItem;

/**
 * @author vmartinon
 *
 */
public class AllUsersViewProvider extends BaseViewProvider implements ICollectionViewProvider<IUser>, ISelectorViewProvider
{
	/** the default class logger */
	private static com.axemble.vdoc.sdk.utils.Logger LOG = com.axemble.vdoc.sdk.utils.Logger.getLogger(AllUsersViewProvider.class);

	/**
	 * @param context
	 * @param view
	 */
	public AllUsersViewProvider (INavigateContext context, CtlAbstractView view)
	{
		super(context, view);
	}

	/**
	 * @see com.axemble.vdp.ui.core.providers.ICollectionViewProvider#getObjects()
	 */
	@Override
	public Collection<IUser> getObjects()
	{
		Collection<IUser> users = new ArrayList<>();
		IDirectoryModule directoryModule = Modules.getDirectoryModule();
		try
		{
			users.addAll(directoryModule.getUsers(getLoggedOnContext()));
		}
		finally
		{
			Modules.releaseModule(directoryModule);
		}
		return users;
	}

	/**
	 * @see com.axemble.vdp.ui.core.providers.ISelectableViewProvider#fetchLine(java.lang.Object)
	 */
	@Override
	public ViewModelItem fetchLine(IUser user)
	{
		ViewModelItem viewModelItem = new ViewModelItem(user);
		viewModelItem.setValue("firstName", user.getFirstName());
		viewModelItem.setValue("lastName", user.getLastName());
		viewModelItem.setValue("email", user.getEmail());
		viewModelItem.setValue("organization", user.getOrganization().getLabel());
		return viewModelItem;
	}

	/**
	 * @see com.axemble.vdp.ui.core.providers.ISelectorViewProvider#onActivate()
	 */
	@Override
	public void onActivate()
	{

	}

	/**
	 * @see com.axemble.vdp.ui.core.providers.ISelectorViewProvider#onOpen()
	 */
	@Override
	public void onOpen()
	{
		// We hide dynamically the second link if sysadmin (no organization, so we don't need...)
		com.axemble.vdp.ui.framework.composites.base.CtlAbstractExplorer.CtlTabsGroup.CtlLauncher launcher = (com.axemble.vdp.ui.framework.composites.base.CtlAbstractExplorer.CtlTabsGroup.CtlLauncher)getParentSelector().getExplorer().getTabsGroup().getCurrentTab();
		((CtlExplorerLink)launcher.getLinks().get(3)).setHidden(getWorkflowModule().getLoggedOnUser().isSysadmin());
	}

}
